
enum {
	KEYFLAG_MAKE = 0x80,
};


int ps2encode(unsigned char number, unsigned short keyflag, void (*output)(unsigned char c, void *cookie), void *cookie)
{
#define OUTPUT(C) output(C, cookie)

	switch (number) {
	case 58:	// ctr
	case 64:	// ctr
		if (keyflag & KEYFLAG_MAKE) {
			OUTPUT(0x14);
		} else {
			OUTPUT(0xf0);
			OUTPUT(0x14);
		}
		break;
	case 60:	// alt
	case 62:	// alt
		if (keyflag & KEYFLAG_MAKE) {
			OUTPUT(0x11);
		} else {
			OUTPUT(0xf0);
			OUTPUT(0x11);
		}
		break;
	case 76:	// del
		if (keyflag & KEYFLAG_MAKE) {
			OUTPUT(0xe0);
			OUTPUT(0x71);
		} else {
			OUTPUT(0xe0);
			OUTPUT(0xf0);
			OUTPUT(0x71);
		}
		break;
	}

#undef OUTPUT
}



